# 格子坐标
ps = {0: (0, 0), 1: (0, 1), 2: (0, 2),
         3: (1, 0), 4:(1, 1),5: (1, 2), 
         6: (2, 0), 7: (2, 1), 8: (2, 2)}
# 可移动位置关系
cr = {0: (1, 3), 1: (0, 2, 4), 2: (1, 5),
      3: (0, 4, 6), 4: (1, 3, 5, 7), 5: (2, 4, 8),
      6: (3, 7), 7: (4, 6, 8), 8: (5, 7)}
# steps存储步骤，puzs存储用过排列布局
steps, puzs = [], []

# 评估差异度
def comp_differ(data):     
    f, h = [], []
    for index, n in enumerate(data):
        if n == 0: continue
        if index== n - 1: f.append(0)
        else: f.append(1)
        cx, cy = index // 3, index % 3
        x, y = ps[n - 1]
        h.append(abs(cx - x) + abs(cy - y))
    return sum(f) + sum(h)


#根据差异评估值，筛选出差异度更小的排列方案
def get_steps(data):                  
    i0 = data.index(0)                  #找到空格的位置
    ds = [data[ci] for ci in cr[i0]]   # 根据空格位置，获取可能交换的格子
    r, dif = None, 100        # 默认交换的格子为None，默认差异度是100
    for d in ds:                   # 对可能的格子进行处理
        t, id = list(data), data.index(d)          
        t[i0], t[id] = t[id], t[i0]                          #交换空格和数码格，形成备选排列t
        if tuple(t) in puzs: continue               #如果排列用过，就尝试下一种排列
        td = comp_differ(t)                            #评估差异度
        if td < dif: dif = td; r = tuple(t)            #把差异度小的方案留下来
    return r

#求解，参数data为初始条件
def solve(data):
    result=False
    while data != (1, 2, 3, 4, 5, 6, 7, 8,0) :                    #未达成目标就循环
        steps.append(data)                                            # 记录步骤
        if data not in puzs: puzs.append(data)              # 记录搜索过的布局
        data = get_steps(data)                                      # 获得下一个排列
        # 当前尝试的排列方案不可行了，退回上一步，尝试其他排列
        if data == None:  
            steps.pop()                                  #操作步骤删除最后一个元素
            data = steps[-1]                           #调用前一步的排列方案，继续尝试
        if len(steps) >  50000: break           # 步数太多就强制退出
    else :result=True
    return result

#计算序列对应的逆序数 
def inverse(data): 
    ns=0
    for i in range(1,9): 
        #0不参与运算
        if data[i]==0 : continue
        for j in range(0,i): 
           #累加统计逆序数
            if data[j ]> data [i] : ns=ns+1
    #返回逆序数
    return ns

#初始状态
a = (8, 1, 3, 4, 0, 2, 7, 5, 6)
if inverse(a) % 2 != 0: 
    print('无解')
else:
    if solve(a) :  
        print(f'解出来了，共{len(steps)}步。')
    else :  
        print('失败了！')
